﻿-- Portrait Timers v1.3
-- Buff/Debuff monitor for default and custom unitframes
-- Written by Killakhan
-- http://www.wowinterface.com/downloads/author-259436.html

local _, L = ...
local PortraitTimers = {}
local addon = PortraitTimers
local version = "1.3"
local addonName = "PT"

local defaults = {
	showArenaAuras = true,
	showPlayerAuras = true,
	showPartyFrames = true,
	showPartyAuras = true,
	fontSize = "Normal",
	r = 1.0,
	g = 1.0,
	b = 1.0,
	a = 1.0,
	arenaFrameScale = 1,
}

addon.fontsDB = {
	["Normal"] = "GameFontNormalLarge",
	["Small"] = "GameFontNormal",
	["Large"] = "GameFontNormalHuge",
}
local UA_localized = GetSpellInfo(68158) -- Unstable Affliction 
local WS_localized = GetSpellInfo(19386) -- Wyvern Sting
addon.spellDB = {
   
	-- Higher up = higher display prio
	
	-- immunitys
	"45438", -- Ice Block
	"33786", -- Cyclone
	"642", -- Divine Shield
	"1022", -- Hand of Protection
	"19263", -- Deterrence
	"46924", -- Bladestorm

	-- stuns
	"408", -- Kidney Shot
	"1833", -- Cheap Shot
	"12809", -- Concussion Blow
	"46968", -- Shockwave
	"853", -- Hammer of Justice
	"49203", -- Hungering Cold
	"85388", -- Throwdown
	"44572", -- Deep Freeze
	"5211", -- Bash
	"19503", -- Scatter Shot
	"30283", -- Shadowfury
	"89605", -- Aura of Foreboding
	"89766", -- Axe Toss
	"22570", -- Maim
	"9005", -- Pounce
	"47481", -- Gnaw
	"1776", -- Gouge
	"6770", -- Sap
	"87195", -- Paralysis
	"88625", -- Holy Word: Chastise   
	"90337", -- Bad Manner (monkey stun)   
	"12489", -- Improved Cone of Cold
	"65929", -- Charge Stun
	"20253", -- Intercept 
	   
	--cc
	"87100", -- Sin and Punishment
	"2637", -- Hibernate
	"605", -- Mind Control
	"64044", -- Psychic Horror
	"2094", -- Blind
	"118", -- Polymorph
	"51514", -- Hex
	"6789", -- Death Coil
	"5246", -- Intimidating Shout 
	"8122", -- Psychic Scream
	"5484", -- Howl of Terror
	"5782", -- Fear
	"6358", -- Seduction
	"1499", -- Freezing Trap
	"20066", -- Repentance
	"339", -- Entangling Roots
	"8377", -- Earthgrab
	"31661", -- Dragon's Breath
	"16689", -- Nature's Grasp
	"82691", -- Ring of Frost
	"23694", -- Improved Hamstring
   
	-- cc immune
	"53271", -- Master's Call
	"1044", -- Hand of Freedom
	"31224", -- Cloak of Shadows
	"51271", -- Pillar of Frost
	
	"31821", -- Aura Mastery
	
	-- dmg reductions
	"48707", -- Anti-Magic Shell
	"30823", -- Shamanistic Rage 
	"33206", -- Pain Suppression
	"47585", -- Dispersion
	"871", -- Shield Wall
	"48792", -- Icebound Fortitude
	"498", -- Divine Protection
	"22812", -- Barkskin
	"61336", -- Survival Instincts	
	"5277", -- Evasion
	"74001", -- Combat Readiness
	"47788", -- Guardian Spirit
   
	-- silences
	"47476", -- Strangulate
	"1330", -- Garrote - Silence
	"55021", -- Silenced - Improved Counterspell
	"15487", -- Silence (priest)
	"19647", -- Spell Lock
	"34490", -- Silencing Shot
	"28730", -- Arcane Torrent
	
	-- disarms
	"676", -- Disarm
	"51722", -- Dismantle
	
	--dmg buffs  
	"34692", -- The Beast Within
	"31884", -- Avenging Wrath
  
	--helpful buffs
	"23920", -- Spell Reflection (warrior)
	"68992", -- Darkflight (Worgen racial)
	"31642", -- Blazing Speed
	"54428", -- Divine Plea
	"2983", -- Sprint
	"1850", -- Dash
	"29166", -- Innervate
}

addon.f = CreateFrame("Frame", addonName.."mainFrame", UIParent)

-- main update frames
addon.TargetFrame = CreateFrame("Frame", addonName.."_TargetFrame", UIParent)
local tFrame = addon.TargetFrame
tFrame:SetWidth(1)
tFrame:SetHeight(1)
tFrame:SetFrameStrata("DIALOG")
addon.FocusFrame = CreateFrame("Frame", addonName.."_FocusFrame", UIParent)
local fFrame = addon.FocusFrame
fFrame:SetWidth(1)
fFrame:SetHeight(1)
fFrame:SetFrameStrata("DIALOG")
addon.PlayerFrame = CreateFrame("Frame", addonName.."_PlayerFrame", UIParent)
local pFrame = addon.PlayerFrame
pFrame:SetWidth(1)
pFrame:SetHeight(1)
pFrame:SetFrameStrata("DIALOG")
for i = 1, 4 do
	addon["PartyFrame"..i] = CreateFrame("Frame", addonName.."_PartyFrame"..i, UIParent)
	local frame = addon["PartyFrame"..i]
	frame:SetWidth(1)
	frame:SetHeight(1)
	frame:SetFrameStrata("DIALOG")
	-- print("created " .. frame:GetName())
end
for i = 1, 5 do
	addon["ArenaFrame"..i] = CreateFrame("Frame", addonName.."_ArenaFrame"..i, UIParent)
	local frame = addon["ArenaFrame"..i]
	frame:SetWidth(1)
	frame:SetHeight(1)
	frame:SetFrameStrata("DIALOG")
	-- print("created " .. frame:GetName())
end

addon.f:SetScript("OnEvent", function(self, event, ...) 
      if addon[event] then 
         return addon[event](addon, event, ...) 
      end 
end)

-- register events
addon.f:RegisterEvent("PLAYER_LOGIN")
addon.f:RegisterEvent("PLAYER_ENTERING_WORLD")
addon.f:RegisterEvent("ADDON_LOADED")
addon.f:RegisterEvent("ARENA_OPPONENT_UPDATE")


-- event functions
function addon:PLAYER_ENTERING_WORLD(event, ...)
	local _, instance = IsInInstance()
	local parent
	if instance == "raid" then
		addon.f:UnregisterEvent("UNIT_AURA")
		addon.f:UnregisterEvent("PLAYER_TARGET_CHANGED")
		addon.f:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		addon.f:UnregisterEvent("PARTY_MEMBERS_CHANGED")
		tFrame:SetScript("OnUpdate", nil)
		tFrame:Hide()
		fFrame:SetScript("OnUpdate", nil)
		fFrame:Hide()
		for i = 1, 4 do
			local frame = addon["PartyFrame"..i]
			frame:Hide()
			frame:SetScript("OnUpdate", nil)
		end
	else
		addon.f:RegisterEvent("UNIT_AURA")      
		addon.f:RegisterEvent("PLAYER_TARGET_CHANGED")
		addon.f:RegisterEvent("PLAYER_FOCUS_CHANGED")
		addon.f:RegisterEvent("PARTY_MEMBERS_CHANGED")
	end
	
	if addon.XPerl_loaded then -- XPerl
		-- target
		if XPerl_Target.conf.portrait3D == 1 then -- name, portrait, parent, frame
			parent = XPerl_TargetportraitFrameportrait3D
		else
			parent = XPerl_TargetportraitFrame
		end
		self.CreateAuraIcons(addonName.."TargetTexture", XPerl_TargetportraitFrame.portrait, parent, tFrame)
		-- focus
		if XPerl_Focus.conf.portrait3D == 1 then
			parent = XPerl_FocusportraitFrameportrait3D
		else
			parent = XPerl_FocusportraitFrame
		end
		self.CreateAuraIcons(addonName.."FocusTexture", XPerl_FocusportraitFrame.portrait, parent, fFrame)
		-- player
		if XPerl_Player.conf.portrait3D == 1 then
			parent = XPerl_PlayerportraitFrameportrait3D
		else
			parent = XPerl_PlayerportraitFrame
		end
		self.CreateAuraIcons(addonName.."PlayerTexture", XPerl_PlayerportraitFrame.portrait, parent, pFrame)
		-- party
		for i = 1, 4 do
			local frame = _G["XPerl_party"..i.."portraitFrame"]
			local partyFrame = _G["XPerl_party"..i]
			if frame and partyFrame then
				if partyFrame.conf.portrait3D == 1 then
					parent = _G["XPerl_party"..i.."portraitFrameportrait3D"]
				else
					parent = frame
				end
				self.CreateAuraIcons(addonName.."PartyTexture"..i, frame.portrait, parent, addon["PartyFrame"..i])
				addon.XPearl_partyEnabled = true
			else
				addon.XPearl_partyEnabled = false
			end
		end
	elseif addon.SUF_loaded then
		-- target
		if ShadowUF.db.profile.units.target.portrait.type == "3D" then
			parent = SUFUnittarget.portraitModel
		else
			parent = SUFUnittarget
		end
		self.CreateAuraIcons(addonName.."TargetTexture", SUFUnittarget.portrait, parent, tFrame)
		-- focus
		if ShadowUF.db.profile.units.focus.portrait.type == "3D" and SUFUnitfocus.portraitModel then
			parent = SUFUnitfocus.portraitModel
		else
			parent = SUFUnitfocus
		end
		self.CreateAuraIcons(addonName.."FocusTexture", SUFUnitfocus.portrait, parent, fFrame)
		-- player
		if ShadowUF.db.profile.units.player.portrait.type == "3D" and SUFUnitplayer.portraitModel then
			parent = SUFUnitplayer.portraitModel
		else
			parent = SUFUnitplayer
		end
		self.CreateAuraIcons(addonName.."PlayerTexture", SUFUnitplayer.portrait, parent, pFrame)
		-- party
		addon.UpdateSUFPartyFrames()
	elseif addon.PitBull_Loaded then
		-- player
		self.CreateAuraIcons(addonName.."PlayerTexture", PitBull4_Frames_player.Portrait, PitBull4_Frames_player.Portrait, pFrame)
		-- party
		-- self.UpdatePitbullPartyFrames()
		addon.checkbox1:Hide()
		return
	else
		self.CreateAuraIcons(addonName.."TargetTexture", TargetFrame.portrait, TargetFrame, tFrame)
		self.CreateAuraIcons(addonName.."FocusTexture", FocusFrame.portrait, FocusFrame, fFrame)
		self.CreateAuraIcons(addonName.."PlayerTexture", PlayerFrame.portrait, PlayerFrame, pFrame)
		-- if self.db.showPartyFrames then
			-- self.f:RegisterEvent("PARTY_MEMBERS_CHANGED")
		-- end
		for i = 1, 4 do
			local frame = _G["PartyMemberFrame"..i]
			if frame then
				self.CreateAuraIcons(addonName.."PartyTexture"..i, frame.portrait, frame, addon["PartyFrame"..i])
			end
		end
		self.checkbox2:Show()
	end

end

function addon:ARENA_OPPONENT_UPDATE(event, unit, status)
	if (unit == "arena1" or unit == "arena2" or unit == "arena3" or unit == "arena4" or unit == "arena5") and status == "seen" then
		-- print("found unit: " .. unit)
		for i = 1, 5 do
			local frame = _G["ArenaEnemyFrame"..i]
			local petFrame = _G["ArenaEnemyFrame"..i.."PetFrame"]
			if frame and petFrame then
				self.CreateAuraIcons(addonName.."ArenaTexture"..i, frame.classPortrait, frame, addon["ArenaFrame"..i])
				frame:SetScale(addon.db.arenaFrameScale)
				petFrame:SetScale(addon.db.arenaFrameScale)
			end
		end
	end
end

function addon:PARTY_MEMBERS_CHANGED(event)
	if addon.SUF_loaded then
		addon.UpdateSUFPartyFrames()
	-- elseif addon.PitBull_Loaded then -- i hate you pitbull
		-- addon.f:SetScript("OnUpdate", addon.UpdatePitbullPartyFrames_delayed)
	end
	-- show blizzard frames
	if self.db.showPartyFrames and not (addon.SUF_loaded or addon.PitBull_Loaded or addon.XPerl_loaded) then
		local _, instance = IsInInstance()
		if instance == "arena" then
			-- print("in arena")
			for i = 1, 4 do
				local unit = "party"..i
				if UnitExists(unit) then
					addon.UpdatePartyFrames(_G["PartyMemberFrame"..i])
				end
			end
		end
	end
end

function addon:UNIT_AURA(event, unit)
	if unit == "target" or unit == "focus" then 
		addon.CheckAura(unit)
	end
	if addon.db.showArenaAuras and (ArenaEnemyFrame1 or ArenaEnemyFrame2 or ArenaEnemyFrame3 or ArenaEnemyFrame4 or ArenaEnemyFrame5) then
		if unit == "arena1" or unit == "arena2" or unit == "arena3" or unit == "arena4" or unit == "arena5" then 
			addon.CheckAura(unit)
		end
	end
	if addon.db.showPartyAuras then
		if unit == "party1" or unit == "party2" or unit == "party3" or unit == "party4" then
			if addon.XPerl_loaded and addon.XPearl_partyEnabled then
				addon.CheckAura(unit)
			elseif addon.SUF_loaded and SUF_partyEnabled then
				addon.CheckAura(unit)
			else
				if (unit == "party1" and (PartyMemberFrame1:IsVisible())) or
					(unit == "party2" and (PartyMemberFrame2:IsVisible())) or
					(unit == "party3" and (PartyMemberFrame3:IsVisible())) or
					(unit == "party4" and (PartyMemberFrame4:IsVisible())) then
					addon.CheckAura(unit)
				end
			end
		end
	end
	if addon.db.showPlayerAuras then
		if unit == "player" then
			addon.CheckAura(unit)
		end
	end
end

function addon:PLAYER_TARGET_CHANGED(event)
	if UnitExists("target") then
		if addon.PitBull_Loaded then
			if not tFrame.auraIcon then
				self.CreateAuraIcons(addonName.."TargetTexture", PitBull4_Frames_target.Portrait, PitBull4_Frames_target.Portrait, tFrame)
			else
			tFrame.auraIcon:SetParent(PitBull4_Frames_target.Portrait) -- pitbull is funny
			end
		end
		addon.CheckAura("target")
	else
		tFrame:Hide()
	end
end
function addon:PLAYER_FOCUS_CHANGED(event)
	if UnitExists("focus") then
		if addon.PitBull_Loaded then
			if not fFrame.auraIcon then
				self.CreateAuraIcons(addonName.."FocusTexture", PitBull4_Frames_focus.Portrait, PitBull4_Frames_focus.Portrait, fFrame)
			end
			fFrame.auraIcon:SetParent(PitBull4_Frames_focus.Portrait) -- pitbull is funny
		end
		addon.CheckAura("focus")
	else
		fFrame:Hide()
	end
end

function addon:ADDON_LOADED(event, addon)
	if addon == "PortraitTimers" then
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rPortrait Timers v"..version.." Loaded")

		if not PortraitTimersDB then
			PortraitTimersDB = {}
		end
		self.db = self.CopyDefaults(defaults, PortraitTimersDB)
		
		self.CreateConfig()
		UIDropDownMenu_SetText(self.dropdown1, self.db.fontSize)
		self.colorButton.texture:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
		self.colorButton.texture:SetTexture(self.db.r, self.db.g, self.db.b)
		self.checkbox1:SetChecked(self.db.showPartyAuras)
		self.checkbox2:SetChecked(self.db.showPartyFrames)
		self.checkbox3:SetChecked(self.db.showPlayerAuras)
		self.checkbox4:SetChecked(self.db.showArenaAuras)
		self.slider1:SetValue(self.db.arenaFrameScale)
		self.arenaTextureFrame:SetScale(self.db.arenaFrameScale)
		self.f:UnregisterEvent("ADDON_LOADED")
	end
end

function addon:PLAYER_LOGIN(event)
	if IsAddOnLoaded("AuraTimers")  then -- check for old addon
		self.AT_loaded = true
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |c00FF0000Warning!|r You must remove any previous versions of AuraTimers before installing PortraitTimers!")
		return
	end
	if IsAddOnLoaded("PitBull4") then -- check for pitbull
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rPitBull4 Detected.")
		self.PitBull_Loaded = true
	end
	if IsAddOnLoaded("XPerl") then -- check for xperl
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rXPerl Detected.")
		self.XPerl_loaded = true
	end
	if IsAddOnLoaded("ShadowedUnitFrames") then -- check for sUF
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF9900[PT]: |rsUF Detected.")
		self.SUF_loaded = true
	end
end

-- other functions

function addon.UpdateSUFPartyFrames()
	-- sUF party frames
	if addon.SUF_loaded then
		local parent
		for i = 1, 4 do
			local frame = _G["SUFHeaderpartyUnitButton"..i]
			if frame and frame.portrait then
				if ShadowUF.db.profile.units.party.portrait.type == "3D" then
					parent = frame.portraitModel
				else
					parent = frame
				end
				addon.CreateAuraIcons(addonName.."PartyTexture"..i, frame.portrait, parent, addon["PartyFrame"..i])
				addon.SUF_partyEnabled = true
			else
				addon.SUF_partyEnabled = false
			end
		end
	end
end
-- function addon.UpdatePitbullPartyFrames()
	-- if addon.PitBull_Loaded then
		-- local parent
		-- for i = 1, 4 do
			-- local frame = _G["PitBull4_Groups_PartyUnitButton"..i]
			-- if frame then
			-- print("found frame " .. frame:GetName())
				-- addon.CreateAuraIcons(addonName.."PartyTexture"..i, frame.Portrait, frame.Portrait, addon["PartyFrame"..i])
			-- end
		-- end
	-- end
-- end
-- local total = 0
-- function addon.UpdatePitbullPartyFrames_delayed(self, elapsed)
	-- total = total + elapsed
	-- if total >= 0.01 then
		-- addon.UpdatePitbullPartyFrames()
		-- addon.f:SetScript("OnUpdate", nil)
	-- end
-- end

function addon.UpdatePartyFrames(self)
	local id = self:GetID();
	if ( GetPartyMember(id) ) then
		self:Show();
		
		UnitFrame_Update(self);
		
		local masterIcon = _G[self:GetName().."MasterIcon"];
		local lootMethod;
		local lootMaster;
		lootMethod, lootMaster = GetLootMethod();
		if ( id == lootMaster ) then
			masterIcon:Show();
		else
			masterIcon:Hide();
		end
	else
		self:Hide();
	end
	PartyMemberFrame_UpdatePet(self);
	PartyMemberFrame_UpdatePvPStatus(self);
	RefreshDebuffs(self, "party"..id, nil, nil, true);
	PartyMemberFrame_UpdateVoiceStatus(self);
	PartyMemberFrame_UpdateReadyCheck(self);
	PartyMemberFrame_UpdateOnlineStatus(self);
	PartyMemberFrame_UpdatePhasingDisplay(self);
	UpdatePartyMemberBackground();
	-- print("created " .. self:GetName())
end

function addon.CopyDefaults(src, dst)
	if not src then return { } end
	if not dst then dst = { } end
	for k, v in pairs(src) do
		if type(v) == "table" then
			dst[k] = addon.CopyDefaults(v, dst[k])
		elseif type(v) ~= type(dst[k]) then
			dst[k] = v
		end
	end
	return dst
end

function addon.CreateAuraIcons(name, portrait, parent, frame)
	if frame.auraIcon or not (parent and portrait) then return end
	frame.auraIcon = parent:CreateTexture(name, "OVERlAY")
	frame.auraIcon:SetPoint("CENTER", portrait)
	frame.auraIcon:SetAllPoints(portrait)
	if not frame.font then
		addon.CreateFontStrings(name .. "_Font", frame)
	end
	-- print("Created " .. frame.auraIcon:GetName())
end

function addon.CreateFontStrings(name, frame)
	local fontString
	for k, v in pairs(addon.fontsDB) do
		if k == addon.db.fontSize then
			-- print(k, v)
			fontString = v
		end
	end
	frame.font = frame:CreateFontString(name, "OVERLAY")
	frame.font:SetPoint("CENTER", frame.auraIcon, "CENTER")
	
	local newfont, size = _G[fontString]:GetFont()
	frame.font:SetFont(newfont, size, "OUTLINE")
	frame.font:SetText("")
	frame.font:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
	-- print("Created " .. frame.font:GetName())
end

function addon.SetFontSize(newFont, frame)
	if frame.font then
		local outlineFont, size = _G[newFont]:GetFont()
		frame.font:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
		if frame:GetName():find("Party") or frame:GetName():find("Arena") then
			frame.font:SetFont(outlineFont, size/1.3, "OUTLINE")
		else
			frame.font:SetFont(outlineFont, size, "OUTLINE")
		end
	end
end

function addon.HideAll(unit)
	-- print("hide frame " .. unit)
	local frame = addon.GetUnitFrame(unit)
	if not frame then return end
	frame:Hide()
	if frame.auraIcon then
		frame.auraIcon:Hide()
	end
	if frame.font then
		frame.font:SetText("")
	end
end

function addon.CheckAura(unit)
	for idx, spellID in ipairs(addon.spellDB) do
		local spell = GetSpellInfo(spellID)
		if UnitBuff(unit, spell) then
			local _, _, texture, _, _, _, eTime = UnitBuff(unit, spell)
			addon.SetAura(unit, texture, eTime)
			-- print("found buff " .. spell .. " on " .. unit)
			return
		elseif UnitDebuff(unit, spell) then
			local _, _, texture, _, _, _, eTime = UnitDebuff(unit, spell)
			addon.SetAura(unit, texture, eTime)
			-- print("found debuff " .. spell .. " on " .. unit)
			return
		end
	end
	if UnitDebuff(unit, UA_localized) then  -- check for UA silence
		local _, _, texture, _, _, _, eTime = UnitDebuff(unit, UA_localized)
		if texture == "Interface\\Icons\\Spell_Holy_Silence" then
			addon.SetAura(unit, texture, eTime)
		else
			addon.HideAll(unit)
		end
		return
	end
	if UnitDebuff(unit, WS_localized) then  -- check for Wyvern Sting
		local id = select(11, UnitDebuff(unit, WS_localized))
		if id == 19386 then
			local _, _, texture, _, _, _, eTime = UnitDebuff(unit, WS_localized)
			addon.SetAura(unit, texture, eTime)
			-- print("found wyvern sting debuff")
			return
		end
	end
	
	addon.HideAll(unit)
end

function addon.SetPortraitTexture(frame, texture)
	if not frame then return end
	if addon.PitBull_Loaded then
		frame.auraIcon:SetTexture(texture)
		frame.auraIcon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	elseif addon.XPerl_loaded or addon.SUF_loaded then
		frame.auraIcon:SetTexture(texture)
	else
		SetPortraitToTexture(frame.auraIcon, texture)
	end
end

function addon.SetAura(unit, texture, eTime)
	local frame = addon.GetUnitFrame(unit)
	if not frame then return end
	if not frame.auraIcon then return end
	-- print("updating frame: " .. frame:GetName() .. " tex: " .. texture)
	addon.SetPortraitTexture(frame, texture)
	addon.SetFontSize(addon.fontsDB[addon.db.fontSize], frame)
	frame.texture = texture
	frame.font:SetText(string.format("%.1f", eTime-GetTime()))
	frame.eTime = eTime
	frame.name = unit
	frame:Show()
	frame.auraIcon:Show()
	frame:SetScript("OnUpdate", addon.UpdateTimer)
end

local total = 0.01
function addon.UpdateTimer(self, elapsed)
	total = total + elapsed
	if total >= 0.01 then 
		if self.eTime - GetTime() > 0 and UnitExists(self.name) and self:IsVisible() then
			addon.SetPortraitTexture(self, self.texture)	
			self.font:SetText(string.format("%.1f", self.eTime-GetTime()))
			-- print(self.auraIcon:GetName(), self.eTime-GetTime())
			total = 0
		else
			addon.HideAll(self.name)
		end
	end
end

function addon.GetUnitFrame(unit)
	local frame
	if unit == "target" then
		frame = tFrame
	elseif unit == "focus" then
		frame = fFrame
	elseif unit == "player" then
		frame = pFrame
	elseif unit == "party1" then
		frame = addon.PartyFrame1
	elseif unit == "party2" then
		frame = addon.PartyFrame2
	elseif unit == "party3" then
		frame = addon.PartyFrame3
	elseif unit == "party4" then
		frame = addon.PartyFrame4
	elseif unit == "arena1" then
		frame = addon.ArenaFrame1
	elseif unit == "arena2" then
		frame = addon.ArenaFrame2
	elseif unit == "arena3" then
		frame = addon.ArenaFrame3
	elseif unit == "arena4" then
		frame = addon.ArenaFrame4
	elseif unit == "arena5" then
		frame = addon.ArenaFrame5
	end	
	return frame
end

function addon.ShowColorPicker(r, g, b, changedCallback)
	ColorPickerFrame.opacity  = 1
	ColorPickerFrame.hasOpacity = false
	ColorPickerFrame.previousValues = {r,g,b}
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = 
	changedCallback, changedCallback, changedCallback;
	ColorPickerFrame:Hide(); -- Need to run the OnShow handler.
	ColorPickerFrame:Show();
end

function addon.myColorCallback(restore)
	local newR, newG, newB
	if restore then -- canel
		newR, newG, newB = unpack(restore);
	else
		newR, newG, newB = ColorPickerFrame:GetColorRGB();
	end
	addon.db.r, addon.db.g, addon.db.b = newR, newG, newB
	addon.colorButton.texture:SetTexture(addon.db.r, addon.db.g, addon.db.b)
	addon.testFont:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
	addon.testFont2:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
	addon.arenaTextureFrame.font:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
end

-- config
function addon.CreateConfig()

	addon.panel = CreateFrame("Frame", addonName.."panel", UIParent)
	addon.panel.name = "PortraitTimers"
	InterfaceOptions_AddCategory(addon.panel)

	addon.title = addon.panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	addon.title:SetPoint("TOPLEFT", 16, -16)
	addon.title:SetText(L["PortraitTimers Config"])

	addon.subtitle = addon.panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	addon.subtitle:SetPoint("TOPLEFT", addon.title, "BOTTOMLEFT", 0, -8)
	addon.subtitle:SetNonSpaceWrap(true)
	addon.subtitle:SetText("v"..version)
	addon.subtitle:SetTextColor(1, 1, 1, 0.5)

	addon.dropdown1 = CreateFrame("Frame", addonName.."dropdown1", addon.panel, "UIDropDownMenuTemplate")
	addon.dropdown1:SetPoint("TOPLEFT", addon.subtitle, "BOTTOMLEFT", -10, -30)
	addon.dropdown1:SetWidth(40)
	addon.dropdown1.font = addon.dropdown1:CreateFontString(addonName.."dropdownFont", "ARTWORK", "GameFontNormalSmall")
	addon.dropdown1.font:SetPoint("BOTTOMLEFT", addon.dropdown1, "TOPLEFT", 20, 0)
	addon.dropdown1.font:SetText(L["Font Size:"])
	_G[addon.dropdown1:GetName().."Button"]:SetScript("OnClick", function(self, button, down)
		  ToggleDropDownMenu(1, nil, addon.dropdown1, self:GetName(), -100 ,0)
	end)

	local info = {}

	function addon.dropdown1.initialize(self, level)
		if not level then return end
		wipe(info)
		if level == 1 then
			addon.CreateMenu(info)
		end
	end

	function addon.OnClickFunc(button, arg1, arg2, checked)
		addon.db.fontSize = arg1
		-- addon.SetFontSize(arg2, addon.testFont)
		local newfont, size = _G[arg2]:GetFont()
		addon.testFont:SetFont(newfont, size, "OUTLINE")
		addon.testFont2:SetFont(newfont, size/1.3, "OUTLINE")
		addon.arenaTextureFrame.font:SetFont(newfont, size/1.3, "OUTLINE")
		-- print("selected " .. arg1, arg2)
		UIDropDownMenu_SetText(addon.dropdown1, arg1)
	end	
		
	function addon.CreateMenu(info)
		for k, v in pairs(addon.fontsDB) do
			info.text = k
			info.isTitle = nil
			info.notCheckable = nil
			info.func = addon.OnClickFunc
			info.arg1 = k
			info.arg2 = v
			info.fontObject = addon[k]
			info.checked = addon.isCurrent(k)
			UIDropDownMenu_AddButton(info)
		end
	end	

	function addon.isCurrent(font)
		if addon.db.fontSize == font then
			return true
		else
			return false
		end
	end

--------	Test icons
	addon.texture = addon.panel:CreateTexture()
	addon.texture:SetTexture("Interface\\Icons\\Spell_Holy_SealOfValor")
	addon.texture:SetPoint("LEFT", addon.dropdown1, "RIGHT", 200, 0)
	
	addon.testFont = addon.panel:CreateFontString(nil, "ARTWORK")
	addon.testFont:SetPoint("CENTER", addon.texture, "CENTER")
	local newfont, size = _G[addon.fontsDB[addon.db.fontSize]]:GetFont()
	addon.testFont:SetFont(newfont, size, "OUTLINE")
	addon.testFont:SetText("8.2")
	addon.testFont:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)

	addon.texture2 = addon.panel:CreateTexture()
	addon.texture2:SetTexture("Interface\\Icons\\Spell_Shadow_NetherCloak")
	addon.texture2:SetPoint("LEFT", addon.texture, "RIGHT", 0, 0)
	addon.texture2:SetHeight(40)
	addon.texture2:SetWidth(40)
	
	addon.testFont2 = addon.panel:CreateFontString(nil, "ARTWORK")
	addon.testFont2:SetPoint("CENTER", addon.texture2, "CENTER")
	local newfont, size = _G[addon.fontsDB[addon.db.fontSize]]:GetFont()
	addon.testFont2:SetFont(newfont, size/1.3, "OUTLINE")
	addon.testFont2:SetText("4.9")
	addon.testFont2:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
-------------
	
	addon.colorButton = CreateFrame("Button", nil, addon.panel, "OptionsCheckButtonTemplate")
	local frame = addon.colorButton
	frame:SetPoint("TOP", addon.dropdown1, "BOTTOM", 100, -10)
	frame:SetHighlightTexture("Interface\\Buttons\\CheckButtonHilight")
	frame:SetScript("OnClick", function(self)
		addon.ShowColorPicker(addon.db.r, addon.db.g, addon.db.b, addon.myColorCallback);
	end)
	
	frame.texture = frame:CreateTexture(nil, "OVERLAY")
	frame.texture:SetTexture("Interface\\ChatFrame\\ChatFrameColorSwatch")
	frame.texture:SetTexture(addon.db.r, addon.db.g, addon.db.b)
	frame.texture:SetPoint("CENTER", frame, "CENTER")
	frame.texture:SetHeight(frame:GetHeight()/2)
	frame.texture:SetWidth(frame:GetHeight()/2)

	frame.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.text:SetPoint("RIGHT", frame, "LEFT")
	frame.text:SetText(L["Font Color:"])
	
	addon.checkbox3 = CreateFrame("CheckButton", addonName.."checkbox3", addon.panel, "ChatConfigCheckButtonTemplate")
	addon.checkbox3:SetPoint("LEFT", addon.panel, "LEFT", 20, 40)
	_G[addon.checkbox3:GetName().."Text"]:SetText(L["Enable on Player Frame"])
	_G[addon.checkbox3:GetName().."Text"]:SetPoint("LEFT", addon.checkbox3, "RIGHT", 3, 1)
	addon.checkbox3.tooltip = L["Click to toggle aura display on Player Frame"]
	addon.checkbox3:SetScript("OnClick", function(self, button, down)
		if addon.checkbox3:GetChecked() then
			addon.db.showPlayerAuras = true
		else
			addon.db.showPlayerAuras = false
		end
	end)
	
	addon.checkbox1 = CreateFrame("CheckButton", addonName.."checkbox1", addon.panel, "ChatConfigCheckButtonTemplate")
	addon.checkbox1:SetPoint("TOPLEFT", addon.checkbox3, "BOTTOMLEFT", 0, -5)
	_G[addon.checkbox1:GetName().."Text"]:SetText(L["Enable on Party Frames"])
	_G[addon.checkbox1:GetName().."Text"]:SetPoint("LEFT", addon.checkbox1, "RIGHT", 3, 1)
	addon.checkbox1.tooltip = L["Click to toggle aura display on Party Frames"]
	addon.checkbox1:Show()
	addon.checkbox1:SetScript("OnClick", function(self, button, down)
		if addon.checkbox1:GetChecked() then
			addon.db.showPartyAuras = true
		else
			addon.db.showPartyAuras = false
		end
	end)
	
	addon.checkbox2 = CreateFrame("CheckButton", addonName.."checkbox2", addon.panel, "ChatConfigCheckButtonTemplate")
	addon.checkbox2:SetPoint("TOPLEFT", addon.checkbox1, "BOTTOMLEFT", 15, -5)
	_G[addon.checkbox2:GetName().."Text"]:SetText(L["Always Show Blizzard Party Frames in Arena"])
	_G[addon.checkbox2:GetName().."Text"]:SetPoint("LEFT", addon.checkbox2, "RIGHT", 3, 1)
	addon.checkbox2.tooltip = L["Click to toggle Blizzard Party Frames display"]
	addon.checkbox2:Hide()
	addon.checkbox2:SetScript("OnClick", function(self, button, down)
		if addon.checkbox2:GetChecked() then
			addon.db.showPartyFrames = true
		else
			addon.db.showPartyFrames = false
		end
	end)
	
	addon.checkbox4 = CreateFrame("CheckButton", addonName.."checkbox4", addon.panel, "ChatConfigCheckButtonTemplate")
	addon.checkbox4:SetPoint("TOPLEFT", addon.checkbox1, "BOTTOMLEFT", 0, -35)
	_G[addon.checkbox4:GetName().."Text"]:SetText(L["Enable on Blizzard Arena Frames"])
	_G[addon.checkbox4:GetName().."Text"]:SetPoint("LEFT", addon.checkbox4, "RIGHT", 3, 1)
	addon.checkbox4.tooltip = L["Click to toggle aura display on Blizzard Arena Frames"]
	addon.checkbox4:SetScript("OnClick", function(self, button, down)
		if addon.checkbox4:GetChecked() then
			addon.db.showArenaAuras = true
		else
			addon.db.showArenaAuras = false
		end
	end)
	
	addon.slider1 = CreateFrame("Slider", addonName.."slider1", addon.panel, "OptionsSliderTemplate")
	addon.slider1:SetPoint("TOPLEFT", addon.checkbox4, "BOTTOMLEFT", 5, -25)
	_G[addon.slider1:GetName().."Text"]:SetText(L["Arena Frame Scale: "] .. string.format("%.0f", addon.db.arenaFrameScale*100).."%")
	addon.slider1.tooltipText = L["Drag to set Arena Frame Scale"]
	_G[addon.slider1:GetName().."Low"]:SetText("100%")
	_G[addon.slider1:GetName().."High"]:SetText("200%")
	addon.slider1:SetWidth(155)
	addon.slider1:SetMinMaxValues(1, 2)
	addon.slider1:SetValue(addon.db.arenaFrameScale)
	addon.slider1:SetValueStep(0.1)
	addon.slider1:SetScript("OnValueChanged", function(self, value)
		addon.db.arenaFrameScale = value
		_G[addon.slider1:GetName().."Text"]:SetText(L["Arena Frame Scale: "] .. string.format("%.0f", value*100).."%")
		addon.arenaTextureFrame:SetScale(value)
	end)
	
	addon.arenaTextureFrame = CreateFrame("Frame", nil, addon.panel)
	addon.arenaTextureFrame.tex = addon.arenaTextureFrame:CreateTexture(nil, "OVERLAY")
	addon.arenaTextureFrame.tex:SetTexture("Interface\\ArenaEnemyFrame\\UI-ArenaTargetingFrame")
	addon.arenaTextureFrame.tex:SetTexCoord(0, 0.796, 0, 0.5)
	addon.arenaTextureFrame.tex:SetPoint("TOPLEFT", addon.slider1, "BOTTOMLEFT", 20, -10)
	addon.arenaTextureFrame.tex:SetWidth(102)
	addon.arenaTextureFrame.tex:SetHeight(32)
	addon.arenaTextureFrame.port = addon.arenaTextureFrame:CreateTexture(nil, "ARTWORK")
	SetPortraitToTexture(addon.arenaTextureFrame.port, "Interface\\Icons\\Ability_Rogue_KidneyShot")
	addon.arenaTextureFrame.port:SetPoint("RIGHT", addon.arenaTextureFrame.tex, "RIGHT", -2, 0)
	addon.arenaTextureFrame.port:SetWidth(25)
	addon.arenaTextureFrame.port:SetHeight(25)
	
	addon.numberFrame = CreateFrame("Frame", nil, addon.panel)
	addon.numberFrame:SetFrameStrata("DIALOG")
	addon.arenaTextureFrame.font = addon.numberFrame:CreateFontString(nil, "OVERLAY")
	addon.arenaTextureFrame.font:SetPoint("CENTER", addon.arenaTextureFrame.port, "CENTER")
	local newfont, size = _G[addon.fontsDB[addon.db.fontSize]]:GetFont()
	addon.arenaTextureFrame.font:SetFont(newfont, size/1.3, "OUTLINE")
	addon.arenaTextureFrame.font:SetText("2.7")
	addon.arenaTextureFrame.font:SetTextColor(addon.db.r, addon.db.g, addon.db.b, addon.db.a)
	
end